-- by modelleicher
-- www.schwabenmodding.bplaced.net

-- adds additional particle system 
-- particle system emits if the engine load is above a certain threshold (psThreshold value)
-- maxMotorLoad, the max. value motorLoad can reach witch the particular vehicle (use vehicle debug rendering to figure that value out)
-- Convert to FS17: CatFan18 Mods 13.04.2017
-- Convert to FS19: ? Small Fix:The Man Who Sold The World
-- Custom Heaven Editiom


newExhaustEffects = {};

function newExhaustEffects.prerequisitesPresent(specializations)
    return true;
end;

function newExhaustEffects.registerEventListeners(vehicleType)	
	SpecializationUtil.registerEventListener(vehicleType, "onLoad", newExhaustEffects)
	SpecializationUtil.registerEventListener(vehicleType, "onUpdate", newExhaustEffects)
	SpecializationUtil.registerEventListener(vehicleType, "onDelete", newExhaustEffects)
end

function newExhaustEffects:onLoad(savegame)
   local spec = self.spec_motorized
    self.nrep = {}; -- all variables will be stored in this table to prevent interference with other scripts 
    self.nrep.maxMotorLoad = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.newExhaustEffects#maxMotorLoad"), 20);
    self.nrep.psThreshold = Utils.getNoNil(getXMLFloat(self.xmlFile, "vehicle.newExhaustEffects#psThreshold"), 0.85);
    
    self.nrep.ps = {};
    ParticleUtil.loadParticleSystem(self.xmlFile, self.nrep.ps, "vehicle.newExhaustEffects.particle", self.components, false, nil, self.baseDirectory)
end;

function newExhaustEffects:onUpdate(dt)    
  local spec = self.spec_motorized
    if self:getIsActive() and self.spec_motorized.isMotorStarted then     
   
        local mLoad = self:getMotorLoadPercentage()
        if mLoad > self.nrep.psThreshold then
            ParticleUtil.setEmittingState(self.nrep.ps, true);
        else
            ParticleUtil.setEmittingState(self.nrep.ps, false)
        end;
    end;
end;

function newExhaustEffects:onDelete()
   local spec = self.spec_motorized
    if self.nrep.ps ~= nil then
        ParticleUtil.deleteParticleSystem(self.nrep.ps);
    end;
end;
